-- Author Zen aka Zenchina
-- NitroZen
-- Specialization for Lazarence TJ 800
-- Leave credits if you use it
--


NitroZen = {};

function NitroZen.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function NitroZen:load(xmlFile)
    self.NitroZenState = NitroZen.NitroZenState;
    self.NitroZenActive = false;
	  self.hudNitroZenPosX = 0.95;
    self.hudNitroZenWidth = 0.04;
    self.hudNitroZenPosY = 0.61;
    self.hudNitroZenHeight = 0.06;
   	self.infoPanelNitroZenONPath = Utils.getFilename("textures/NitroZenON.dds", self.baseDirectory);
  	self.hudNitroZenONOverlay = Overlay:new("NitroZenON", self.infoPanelNitroZenONPath, self.hudNitroZenPosX, self.hudNitroZenPosY, self.hudNitroZenWidth, self.hudNitroZenHeight);
  	self.infoPanelNitroZenOFFPath = Utils.getFilename("textures/NitroZenOFF.dds", self.baseDirectory);
  	self.hudNitroZenOFFOverlay = Overlay:new("NitroZenOFF", self.infoPanelNitroZenOFFPath, self.hudNitroZenPosX, self.hudNitroZenPosY, self.hudNitroZenWidth, self.hudNitroZenHeight);
  	self.showhudNitroZen = false;
  	local lampscount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cabLights#count"), 0);
  	self.cabLights = {};
    	if lampscount ~= 0 then
    		for i=1, lampscount do
    			local lampnumber = string.format("vehicle.cabLights.lamp%d", i);	
    			self.cabLights[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, lampnumber .. "#index"));	
  		end;	
  	end;

end;

function NitroZen:delete()
    if self.hudNitroZenONOverlay ~= nil or self.hudNitroZenOFFOverlay ~= nil then
    	self.hudNitroZenONOverlay:delete();
  		self.hudNitroZenOFFOverlay:delete();		
  	end;
end;

function NitroZen:readStream(streamId, connection)  
     self:NitroZenState(streamReadBool(streamId), true);  
end;

function NitroZen:writeStream(streamId, connection)  
    streamWriteBool(streamId, self.NitroZenActive);  
end;

function NitroZen:mouseEvent(posX, posY, isDown, isUp, button)
end;
function NitroZen:keyEvent(unicode, sym, modifier, isDown)
end;

function NitroZen:NitroZenState(state, noEventSend)  
    NitroZenStateEvent.sendEvent(self, state, noEventSend);	
    self.NitroZenActive = state;
end;

function NitroZen:update(dt)
    if self:getIsActiveForInput() then  
		  if InputBinding.hasEvent(InputBinding.NitroZen) then
  		  self:NitroZenState(not self.NitroZenActive);
  		end;
    end;	
	if self:getIsActive() then	
   		if self.NitroZenActive == true then
  			self.showhudNitroZen = true;
        self.motor.maxRpm[3] =2990
        self.fuelUsage =0.0049
    		setVisibility(self.cabLights[3], true)
    		setVisibility(self.cabLights[5], true)
    		setVisibility(self.cabLights[2], true)
  		else
	   		self.showhudNitroZen = false;
        self.motor.maxRpm[3] =2250
        self.fuelUsage =0.0038
    		setVisibility(self.cabLights[3], false)
    		setVisibility(self.cabLights[5], false)
    		setVisibility(self.cabLights[2], false)
	   	end; 	
    end; 
end;

function NitroZen:draw()
   if self.showhudNitroZen == true then
      	self.hudNitroZenONOverlay:render();
	--	g_currentMission:addHelpButtonText(g_i18n:getText("NitroZenOFF"), InputBinding.NitroZen);	
	else
	--	g_currentMission:addHelpButtonText(g_i18n:getText("NitroZenON"), InputBinding.NitroZen);		
	    self.hudNitroZenOFFOverlay:render();
   end;
end;

NitroZenStateEvent = {};
NitroZenStateEvent_mt = Class(NitroZenStateEvent, Event);

InitEventClass(NitroZenStateEvent, "NitroZenStateEvent");

function NitroZenStateEvent:emptyNew() 
    local self = Event:new(NitroZenStateEvent_mt );
    self.className="NitroZenStateEvent";
    return self;
end;

function NitroZenStateEvent:new(vehicle, state) 
    self.vehicle = vehicle;
    self.state = state;
    return self;
end;

function NitroZenStateEvent:readStream(streamId, connection)  
    local id = streamReadInt32(streamId); 
    self.state = streamReadBool(streamId); 
    self.vehicle = networkGetObject(id); 
    self:run(connection);  
end;

function NitroZenStateEvent:writeStream(streamId, connection)   
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
    streamWriteBool(streamId, self.state );   
end;

function NitroZenStateEvent:run(connection)  
    self.vehicle:NitroZenState(self.state, true);
	if not connection:getIsServer() then  
		g_server:broadcastEvent(NitroZenStateEvent:new(self.vehicle, self.state), nil, connection, self.object);
	end;
end;

function NitroZenStateEvent.sendEvent(vehicle, state, noEventSend)  
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then  
			g_server:broadcastEvent(NitroZenStateEvent:new(vehicle, state), nil, nil, vehicle);
		else 
			g_client:getServerConnection():sendEvent(NitroZenStateEvent:new(vehicle, state));
		end;
	end;
end;

